---
apiVersion: apiextensions.k8s.io/v1
kind: CustomResourceDefinition
metadata:
  annotations:
    controller-gen.kubebuilder.io/version: v0.6.1
  creationTimestamp: null
  name: patches.patch.risserlabs.com
spec:
  group: patch.risserlabs.com
  names:
    kind: Patch
    listKind: PatchList
    plural: patches
    singular: patch
  scope: Namespaced
  versions:
    - name: v1alpha1
      schema:
        openAPIV3Schema:
          description: Patch is the Schema for the patches API
          properties:
            apiVersion:
              description:
                "APIVersion defines the versioned schema of this representation
                of an object. Servers should convert recognized schemas to the latest
                internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources"
              type: string
            kind:
              description:
                "Kind is a string value representing the REST resource this
                object represents. Servers may infer this from the endpoint the client
                submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds"
              type: string
            metadata:
              type: object
            spec:
              description: the desired state of the patch
              properties:
                epoch:
                  description: change epoch to force recalibration
                  type: string
                image:
                  description: image used in the job
                  type: string
                patches:
                  description: a list of patches to be applied in order
                  items:
                    description:
                      you can read more about kubernetes patches at the following
                      link https://kubernetes.io/docs/tasks/manage-kubernetes-objects/update-api-object-kubectl-patch
                    properties:
                      id:
                        description: optional patch id for reference
                        type: string
                      patch:
                        description: the patch to apply
                        type: string
                      skipIf:
                        description: skip patch if criteria met
                        items:
                          properties:
                            jsonPath:
                              description: the json patch to check the criteria against
                              type: string
                            regex:
                              description: an extended grep compatible regular expression
                              type: string
                            target:
                              description:
                                the target to check criteria against. if
                                no target specified, the target being patched will be
                                used
                              properties:
                                apiVersion:
                                  type: string
                                group:
                                  type: string
                                kind:
                                  type: string
                                name:
                                  type: string
                                namespace:
                                  type: string
                                version:
                                  type: string
                              required:
                                - kind
                                - name
                              type: object
                          type: object
                        type: array
                      target:
                        description: the resource to patch
                        properties:
                          apiVersion:
                            type: string
                          group:
                            type: string
                          kind:
                            type: string
                          name:
                            type: string
                          namespace:
                            type: string
                          version:
                            type: string
                        required:
                          - kind
                          - name
                        type: object
                      type:
                        description:
                          you can read more about the patch types at the
                          following link https://kubernetes.io/docs/tasks/manage-kubernetes-objects/update-api-object-kubectl-patch/#use-a-json-merge-patch-to-update-a-deployment
                        type: string
                      waitForResource:
                        description: wait for the resource to exist
                        type: boolean
                      waitForTimeout:
                        description: wait for time in milliseconds before applying patch
                        type: integer
                    required:
                      - patch
                      - target
                    type: object
                  type: array
              type: object
            status:
              description: PatchStatus defines the observed state of Patch
              properties:
                conditions:
                  description:
                    Conditions represent the latest available observations
                    of an object's state
                  items:
                    description:
                      "Condition contains details for one aspect of the current
                      state of this API Resource. --- This struct is intended for direct
                      use as an array at the field path .status.conditions.  For example,
                      type FooStatus struct{     // Represents the observations of a
                      foo's current state.     // Known .status.conditions.type are:
                      \"Available\", \"Progressing\", and \"Degraded\"     // +patchMergeKey=type
                      \    // +patchStrategy=merge     // +listType=map     // +listMapKey=type
                      \    Conditions []metav1.Condition `json:\"conditions,omitempty\"
                      patchStrategy:\"merge\" patchMergeKey:\"type\" protobuf:\"bytes,1,rep,name=conditions\"`
                      \n     // other fields }"
                    properties:
                      lastTransitionTime:
                        description:
                          lastTransitionTime is the last time the condition
                          transitioned from one status to another. This should be when
                          the underlying condition changed.  If that is not known, then
                          using the time when the API field changed is acceptable.
                        format: date-time
                        type: string
                      message:
                        description:
                          message is a human readable message indicating
                          details about the transition. This may be an empty string.
                        maxLength: 32768
                        type: string
                      observedGeneration:
                        description:
                          observedGeneration represents the .metadata.generation
                          that the condition was set based upon. For instance, if .metadata.generation
                          is currently 12, but the .status.conditions[x].observedGeneration
                          is 9, the condition is out of date with respect to the current
                          state of the instance.
                        format: int64
                        minimum: 0
                        type: integer
                      reason:
                        description:
                          reason contains a programmatic identifier indicating
                          the reason for the condition's last transition. Producers
                          of specific condition types may define expected values and
                          meanings for this field, and whether the values are considered
                          a guaranteed API. The value should be a CamelCase string.
                          This field may not be empty.
                        maxLength: 1024
                        minLength: 1
                        pattern: ^[A-Za-z]([A-Za-z0-9_,:]*[A-Za-z0-9_])?$
                        type: string
                      status:
                        description: status of the condition, one of True, False, Unknown.
                        enum:
                          - "True"
                          - "False"
                          - Unknown
                        type: string
                      type:
                        description:
                          type of condition in CamelCase or in foo.example.com/CamelCase.
                          --- Many .condition.type values are consistent across resources
                          like Available, but because arbitrary conditions can be useful
                          (see .node.status.conditions), the ability to deconflict is
                          important. The regex it matches is (dns1123SubdomainFmt/)?(qualifiedNameFmt)
                        maxLength: 316
                        pattern: ^([a-z0-9]([-a-z0-9]*[a-z0-9])?(\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*/)?(([A-Za-z0-9][-A-Za-z0-9_.]*)?[A-Za-z0-9])$
                        type: string
                    required:
                      - lastTransitionTime
                      - message
                      - reason
                      - status
                      - type
                    type: object
                  type: array
                lastUpdate:
                  description: last update time
                  format: date-time
                  type: string
                message:
                  description: status message
                  type: string
                pauseUntilUpdate:
                  description: pause until update
                  type: boolean
                phase:
                  description: integration plug phase (Pending, Succeeded, Failed, Unknown)
                  type: string
                specHash:
                  description: spec hash
                  type: string
              type: object
          type: object
      served: true
      storage: true
      subresources:
        status: {}
status:
  acceptedNames:
    kind: ""
    plural: ""
  conditions: []
  storedVersions: []
